using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

using RSSReader.OPML;
using RSSReader.RSS;

namespace RSSReader.Controls
{

	/// <summary>
	/// Summary description for FeedListView.
	/// </summary>
	public class FeedListView : System.Windows.Forms.UserControl
	{

		public delegate void FeedItemSelectedHandler( object sender, RSSItem item );
		public delegate void FeedItemChangedHandler( object sender, RSSItem item );

		public event FeedItemSelectedHandler FeedItemSelected;
		public event FeedItemChangedHandler FeedItemChanged;

		#region 

		private System.Windows.Forms.ListView lvwItems;
		private System.Windows.Forms.ColumnHeader chItemTitle;
		private System.Windows.Forms.ColumnHeader chItemDate;
		private System.Windows.Forms.ColumnHeader chItemAuthor;
		private System.Windows.Forms.ColumnHeader chItemSubject;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ImageList listStateImages;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem mnuMarkAsRead;
		private System.Windows.Forms.MenuItem mnuMarkAsUnread;
		private System.Windows.Forms.MenuItem mnuOpenExternal;
		private System.Windows.Forms.MenuItem mnuFollowUp;
		private System.Windows.Forms.MenuItem mnuRemoveFollowUp;
		private System.Windows.Forms.ColumnHeader chMarkedAsRead;
		private System.Windows.Forms.MenuItem mnuDeleteItem;
		private System.ComponentModel.IContainer components;

		public FeedListView()
		{

			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();
			this.Load += new EventHandler(FeedListView_Load);

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FeedListView));
			this.lvwItems = new System.Windows.Forms.ListView();
			this.chMarkedAsRead = new System.Windows.Forms.ColumnHeader();
			this.chItemTitle = new System.Windows.Forms.ColumnHeader();
			this.chItemDate = new System.Windows.Forms.ColumnHeader();
			this.chItemAuthor = new System.Windows.Forms.ColumnHeader();
			this.chItemSubject = new System.Windows.Forms.ColumnHeader();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.mnuMarkAsRead = new System.Windows.Forms.MenuItem();
			this.mnuMarkAsUnread = new System.Windows.Forms.MenuItem();
			this.mnuFollowUp = new System.Windows.Forms.MenuItem();
			this.mnuRemoveFollowUp = new System.Windows.Forms.MenuItem();
			this.mnuOpenExternal = new System.Windows.Forms.MenuItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.listStateImages = new System.Windows.Forms.ImageList(this.components);
			this.mnuDeleteItem = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// lvwItems
			// 
			this.lvwItems.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.lvwItems.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					   this.chMarkedAsRead,
																					   this.chItemTitle,
																					   this.chItemDate,
																					   this.chItemAuthor,
																					   this.chItemSubject});
			this.lvwItems.ContextMenu = this.contextMenu1;
			this.lvwItems.FullRowSelect = true;
			this.lvwItems.HideSelection = false;
			this.lvwItems.LabelWrap = false;
			this.lvwItems.Location = new System.Drawing.Point(0, 0);
			this.lvwItems.MultiSelect = false;
			this.lvwItems.Name = "lvwItems";
			this.lvwItems.Size = new System.Drawing.Size(520, 330);
			this.lvwItems.SmallImageList = this.imageList1;
			this.lvwItems.StateImageList = this.listStateImages;
			this.lvwItems.TabIndex = 7;
			this.lvwItems.View = System.Windows.Forms.View.Details;
			this.lvwItems.MouseDown += new System.Windows.Forms.MouseEventHandler(this.lvwItems_MouseDown);
			this.lvwItems.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.lvwItems_KeyPress);
			this.lvwItems.DoubleClick += new System.EventHandler(this.lvwItems_DoubleClick);
			this.lvwItems.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.lvwItems_ColumnClick);
			this.lvwItems.SelectedIndexChanged += new System.EventHandler(this.lvwItems_SelectedIndexChanged);
			// 
			// chMarkedAsRead
			// 
			this.chMarkedAsRead.Text = "";
			this.chMarkedAsRead.Width = 35;
			// 
			// chItemTitle
			// 
			this.chItemTitle.Text = "Title";
			this.chItemTitle.Width = 256;
			// 
			// chItemDate
			// 
			this.chItemDate.Text = "Date";
			this.chItemDate.Width = 117;
			// 
			// chItemAuthor
			// 
			this.chItemAuthor.Text = "Author";
			this.chItemAuthor.Width = 120;
			// 
			// chItemSubject
			// 
			this.chItemSubject.Text = "Subject";
			this.chItemSubject.Width = 181;
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.mnuMarkAsRead,
																						 this.mnuMarkAsUnread,
																						 this.mnuFollowUp,
																						 this.mnuRemoveFollowUp,
																						 this.mnuOpenExternal,
																						 this.mnuDeleteItem});
			this.contextMenu1.Popup += new System.EventHandler(this.contextMenu1_Popup);
			// 
			// mnuMarkAsRead
			// 
			this.mnuMarkAsRead.Index = 0;
			this.mnuMarkAsRead.Text = "Mark as &Read";
			this.mnuMarkAsRead.Click += new System.EventHandler(this.mnuMarkAsRead_Click);
			// 
			// mnuMarkAsUnread
			// 
			this.mnuMarkAsUnread.Index = 1;
			this.mnuMarkAsUnread.Text = "Mark as &Unread";
			this.mnuMarkAsUnread.Click += new System.EventHandler(this.mnuMarkAsUnread_Click);
			// 
			// mnuFollowUp
			// 
			this.mnuFollowUp.Index = 2;
			this.mnuFollowUp.Text = "Mark for &Follow-Up";
			this.mnuFollowUp.Click += new System.EventHandler(this.mnuFollowUp_Click);
			// 
			// mnuRemoveFollowUp
			// 
			this.mnuRemoveFollowUp.Index = 3;
			this.mnuRemoveFollowUp.Text = "&Remove Follow-Up flag";
			this.mnuRemoveFollowUp.Click += new System.EventHandler(this.mnuRemoveFollowUp_Click);
			// 
			// mnuOpenExternal
			// 
			this.mnuOpenExternal.Index = 4;
			this.mnuOpenExternal.Text = "Open in default &Browser";
			this.mnuOpenExternal.Click += new System.EventHandler(this.mnuOpenExternal_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// listStateImages
			// 
			this.listStateImages.ImageSize = new System.Drawing.Size(16, 16);
			this.listStateImages.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("listStateImages.ImageStream")));
			this.listStateImages.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// mnuDeleteItem
			// 
			this.mnuDeleteItem.Index = 5;
			this.mnuDeleteItem.Text = "&Delete";
			this.mnuDeleteItem.Click += new System.EventHandler(this.mnuDeleteItem_Click);
			// 
			// FeedListView
			// 
			this.Controls.Add(this.lvwItems);
			this.Name = "FeedListView";
			this.Size = new System.Drawing.Size(520, 328);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		private OPMLItemNode		subscription;
		private RSSFeed				feed;
		private ItemSortField		sortColumn = ItemSortField.Date;
		private ItemSortOrder		sortOrder = ItemSortOrder.Descending;
		private ThreadListItem		contextItem;

		public OPMLItemNode Subscription
		{
			
			get { return subscription; }
			
			set 
			{ 

				subscription = value;
				if( value != null )
					RefreshFeed();

			}

		}

		public RSSFeed Feed
		{
			get { return feed; }
		}

		private void FeedListView_Load(object sender, EventArgs e)
		{
			UpdateSortIndicator();
		}

		private void RefreshFeed()
		{

			if( subscription != null )
				feed = FeedManager.GetCachedFeed( subscription.XmlUrl );

			if( feed != null )
				RefreshFeed( feed );

		}

		public void Clear()
		{
			lvwItems.Items.Clear();
		}

		public void RefreshFeed( RSSFeed feed )
		{

			this.feed = feed;
			feed.Sort( sortColumn, sortOrder );

			lvwItems.Items.Clear();

			foreach( RSS.RSSItem feedItem in feed.Items )
			{
				
				if( !feedItem.Deleted )
					ShowFeedItem( feedItem, null );

			}

		}

		private void ShowFeedItem( RSS.RSSItem feedItem, ThreadListItem parent )
		{

			try
			{

				ThreadListItem item = CreateListItemFromRSSItem( feedItem );

				if( parent == null )
					lvwItems.Items.Add( item );
				else
					parent.Items.Add( item );

			}
			catch( Exception err )
			{
				System.Diagnostics.Debug.WriteLine( err.ToString() );
			}

		}

		private int GetImageIndexForItem( ThreadListItem item )
		{

			RSSItem feedItem = (RSSItem) item.Tag;

			if( feedItem.MarkedForFollowUp )
				return 19;
			else if( feedItem.MarkedAsRead )
				return 13;
			else
				return 10;

		}

		private string GetDateString( DateTime date )
		{
			// This was extracted into a method because I thought I'd need to do other 
			// formatting, but ended up deciding that it makes the date formatting more 
			// readable in CreateListItemFromRSSItem()
			return date.ToShortDateString() + " " + date.ToShortTimeString();
		}

		private ThreadListItem CreateListItemFromRSSItem( RSSItem feedItem )
		{

			string title = StripHtml.Strip( System.Web.HttpUtility.HtmlDecode( feedItem.Title ) );

			ThreadListItem item = new ThreadListItem( " " );
			item.SubItems.Add( title );
			item.SubItems.Add( GetDateString( feedItem.DatePublished ) );
			item.SubItems.Add( feedItem.Creator );
			item.SubItems.Add( feedItem.Subject );
			item.Tag = feedItem;
			item.ExpandedChanged += new EventHandler(item_ExpandedChanged);
			item.HasChildItems = (feedItem.Comments != null && feedItem.Comments.Items.Count > 0);
			item.ImageIndex = GetImageIndexForItem( item );

			if( item.HasChildItems )
				item.StateImageIndex = 0;

			return item;
		
		}

		private void GetCommentFeed( ThreadListItem item )
		{

			if( !this.lvwItems.Items.Contains( item ) )
				return;

			RSSItem rssItem = (RSSItem) item.Tag;

			RSSFeed feed = FeedManager.GetCachedFeed( rssItem.CommentFeedUrl );
			if( feed == null )
			{

				item.StateImageIndex = -1;
				item.HasChildItems = false;
				item.ListView.Refresh();

				return;

			}
			else
			{

				item.StateImageIndex = 0;
				item.HasChildItems = true;
				item.ListView.Refresh();

			}

			// Not at all sure why, but comments sort in opposite order of main
			// feed if this is not done. ?????
			if( sortOrder == ItemSortOrder.Ascending )
				feed.Sort( sortColumn, ItemSortOrder.Descending );
			else
				feed.Sort( sortColumn, ItemSortOrder.Ascending );
					
			foreach( RSS.RSSItem feedItem in feed.Items )
			{

				if( feedItem.Deleted )
					continue;

				ThreadListItem childItem = new ThreadListItem( " " );
				childItem.Tag = feedItem;
				childItem.ImageIndex = GetImageIndexForItem( childItem );

				item.Items.Add( childItem );

				string title = System.Web.HttpUtility.HtmlDecode( feedItem.Title );
				childItem.SubItems.Add( title );
				childItem.SubItems.Add( feedItem.DatePublished.ToShortDateString() );
				childItem.SubItems.Add( feedItem.Creator );
				childItem.SubItems.Add( feedItem.Subject );

			}

		}

		private void item_ExpandedChanged(object sender, EventArgs e)
		{

			ThreadListItem item = (ThreadListItem) sender;
			if( item.Expanded )
			{
			
				item.StateImageIndex = 1;
				if( item.Items.Count == 0 )
					GetCommentFeed( item );	

			}
			else
				item.StateImageIndex = 0;

		}

		private void lvwItems_DoubleClick(object sender, System.EventArgs e)
		{
		
			if( contextItem == null )
				return;

			RSS.RSSItem item = (RSS.RSSItem) contextItem.Tag;
			if( !item.MarkedAsRead && this.subscription != null )
			{
				item.MarkedAsRead = true;
				contextItem.ImageIndex = GetImageIndexForItem( contextItem );
				FeedManager.SaveFeed( item.Parent );
			}

			if( this.subscription != null && FeedItemChanged != null )
				FeedItemChanged( this, item );

			if( this.FeedItemSelected != null )
				this.FeedItemSelected( this, item );

		}

		private void lvwItems_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
		
			contextItem = (ThreadListItem) lvwItems.GetItemAt( e.X, e.Y );

			if( e.Button != MouseButtons.Left )
				return;

			Point hitPoint = new Point( e.X, e.Y );
			ListViewItem stateClicked = ListViewHelper.StateImageHitTest( lvwItems, hitPoint );
			if( stateClicked != null )
			{

				stateClicked.Selected = true;

				if( stateClicked is ThreadListItem )
				{
					
					ThreadListItem threaded = (ThreadListItem) stateClicked;
					if( threaded.HasChildItems )
						threaded.Expanded = !threaded.Expanded;

					if( threaded.Expanded )
						threaded.StateImageIndex = 1;
					else if( threaded.HasChildItems )
						threaded.StateImageIndex = 0;

				}

			}

		}

		private void lvwItems_SelectedIndexChanged(object sender, System.EventArgs e)
		{
		
			if( lvwItems.SelectedItems == null || lvwItems.SelectedItems.Count == 0 )
				return;
		
			ListViewItem selected = lvwItems.SelectedItems[0];
			if( selected.Tag == null )
				return;
			else
				this.contextItem = (ThreadListItem) selected;

		}

		private void sorter_BeforeSort(object sender, EventArgs e)
		{

			ListViewItemCollection temp = new ListViewItemCollection();
			foreach( ListViewItem item in lvwItems.Items )
				temp.Add( item );

			foreach( ThreadListItem item in temp )
			{

				if( item.Expanded )
					item.Expanded = false; 

			}
		
		}

		private void OnCommentsRetrieved( RSSFeed feed, object Tag )
		{

			try
			{

				if( feed == null )
					return;

				FeedManager.SaveFeed( feed );
				GetCommentFeed( (ThreadListItem) Tag );

			}
			catch( Exception err )
			{
				System.Diagnostics.Debug.WriteLine( err.ToString() );
			}

		}

		private ItemSortField GetSortFieldForColumn( int Column )
		{

			switch( Column )
			{

				case 0:
					return ItemSortField.MarkedAsRead;

				case 1:
					return ItemSortField.Title;

				case 2:
					return ItemSortField.Date;

				case 3:
					return ItemSortField.Creator;

				case 4:
					return ItemSortField.Subject;

				default:
					return ItemSortField.Date;

			}

		}

		private void UpdateSortIndicator()
		{

			SortOrder order = SortOrder.Ascending;
			if( sortOrder == ItemSortOrder.Descending )
				order = SortOrder.Descending;

			int column = 0;
			switch( sortColumn )
			{

				case ItemSortField.MarkedAsRead:
					column = 0;
					break;
				
				case ItemSortField.Title:
					column = 1;
					break;

				case ItemSortField.Date:
					column = 2;
					break;

				case ItemSortField.Creator:
					column = 3;
					break;

				case ItemSortField.Subject:
					column = 4;
					break;

			}

			ListViewHelper.ShowSortIndicator( lvwItems, column, order );

		}

		private void lvwItems_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
		{

			if( feed == null )
				return;

			ItemSortField column = GetSortFieldForColumn( e.Column );
			if( column == sortColumn )
			{
				if( sortOrder == ItemSortOrder.Ascending )
					sortOrder = ItemSortOrder.Descending;
				else	
					sortOrder = ItemSortOrder.Ascending;
			}
			else
				sortOrder = ItemSortOrder.Ascending;
		
			sortColumn = column;

			RefreshFeed( this.feed );

			UpdateSortIndicator();

		}

		private void contextMenu1_Popup(object sender, System.EventArgs e)
		{

			if( contextItem == null || contextItem.IndentLevel > 0 || subscription == null )
			{

				foreach( MenuItem mnuItem in contextMenu1.MenuItems )
					mnuItem.Visible = false;
				
				return;

			}

			RSS.RSSItem item = (RSS.RSSItem) contextItem.Tag;
			mnuMarkAsRead.Visible = !item.MarkedAsRead;
			mnuMarkAsUnread.Visible = item.MarkedAsRead;
			mnuFollowUp.Visible = !item.MarkedForFollowUp;
			mnuRemoveFollowUp.Visible = item.MarkedForFollowUp;
			mnuOpenExternal.Visible = true;

		}

		private void mnuMarkAsRead_Click(object sender, System.EventArgs e)
		{

			RSS.RSSItem item = (RSS.RSSItem) contextItem.Tag;
			item.MarkedAsRead = true;
			contextItem.ImageIndex = GetImageIndexForItem( contextItem );
			FeedManager.SaveFeed( item.Parent );

			if( FeedItemChanged != null )
				FeedItemChanged( this, item );

		}

		private void mnuMarkAsUnread_Click(object sender, System.EventArgs e)
		{
		
			RSS.RSSItem item = (RSS.RSSItem) contextItem.Tag;
			item.MarkedAsRead = false;
			contextItem.ImageIndex = GetImageIndexForItem( contextItem );
			FeedManager.SaveFeed( item.Parent );

			if( FeedItemChanged != null )
				FeedItemChanged( this, item );

		}

		private void mnuDeleteItem_Click(object sender, System.EventArgs e)
		{

			string confirmMessage = "Are you sure you wish to delete this post?  Deleted posts cannot be recovered.";
			if( MessageBox.Show( confirmMessage, "Confirm Delete", MessageBoxButtons.YesNo ) != DialogResult.Yes )
				return;
		
			RSS.RSSItem item = (RSS.RSSItem) contextItem.Tag;
			item.Deleted = true;
			contextItem.Remove();

			FeedManager.SaveFeed( item.Parent );

			if( FeedItemChanged != null )
				FeedItemChanged( this, item );

		}

		private void mnuOpenExternal_Click(object sender, System.EventArgs e)
		{

			RSS.RSSItem item = (RSS.RSSItem) contextItem.Tag;
			if( !item.MarkedAsRead )
				mnuMarkAsRead_Click( sender, EventArgs.Empty );

			System.Diagnostics.Process.Start( item.Link );

		}

		private void mnuFollowUp_Click(object sender, System.EventArgs e)
		{
		
			RSS.RSSItem item = (RSS.RSSItem) contextItem.Tag;
			item.MarkedForFollowUp = true;
			contextItem.ImageIndex = GetImageIndexForItem( contextItem );
			FeedManager.SaveFeed( item.Parent );

			if( FeedItemChanged != null )
				FeedItemChanged( this, item );

		}

		private void mnuRemoveFollowUp_Click(object sender, System.EventArgs e)
		{
		
			RSS.RSSItem item = (RSS.RSSItem) contextItem.Tag;
			item.MarkedForFollowUp = false;
			contextItem.ImageIndex = GetImageIndexForItem( contextItem );
			FeedManager.SaveFeed( item.Parent );

			if( FeedItemChanged != null )
				FeedItemChanged( this, item );

		}

		private void SelectItem( ThreadListItem item )
		{

			lvwItems.SelectedItems.Clear();
			Application.DoEvents();

			contextItem = item;
			item.Focused = true;
			item.Selected = true;
			item.EnsureVisible();
					
			lvwItems_DoubleClick( lvwItems, EventArgs.Empty );
			Application.DoEvents();
			this.Focus();

		}

		public void SelectNextUnreadItem()
		{

			foreach( ThreadListItem item in lvwItems.Items )
			{

				RSSItem rssItem = (RSS.RSSItem) item.Tag;
				if( !rssItem.MarkedAsRead )
				{
					SelectItem( item );
					break;
				}

			}

		}

		private void lvwItems_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{

			if( e.KeyChar == '\r' )
			{
				e.Handled = true;
				lvwItems_DoubleClick( sender, EventArgs.Empty );
			}
			else if( e.KeyChar == ' ' )
			{

				e.Handled = true;

				ThreadListItem nextItem = null;
				if( lvwItems.SelectedItems.Count == 1 )
					nextItem = (ThreadListItem) lvwItems.SelectedItems[0];

				RSS.RSSItem rssItem = null;
				if( nextItem != null )
				{

					rssItem = (RSS.RSSItem) nextItem.Tag;
					if( rssItem.MarkedAsRead )
						nextItem = null;
					else
						SelectItem( nextItem );

				}

				if( nextItem == null )
					SelectNextUnreadItem();

			}

		}

	}

}
