using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using RSSReader;

namespace RSSReaderPlugin.Forms
{

	/// <summary>
	/// Summary description for SearchLocalFeeds.
	/// </summary>
	public class SearchLocalFeeds : System.Windows.Forms.Form
	{

		#region 

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox SearchTerms;
		private System.Windows.Forms.CheckBox chkCaseSensitive;
		private System.Windows.Forms.Button cmdFind;
		private System.Windows.Forms.Button cmdCancel;
		private System.Windows.Forms.CheckBox chkWholeWord;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SearchLocalFeeds()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.SearchTerms = new System.Windows.Forms.ComboBox();
			this.chkCaseSensitive = new System.Windows.Forms.CheckBox();
			this.cmdFind = new System.Windows.Forms.Button();
			this.cmdCancel = new System.Windows.Forms.Button();
			this.chkWholeWord = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(68, 18);
			this.label1.TabIndex = 0;
			this.label1.Text = "Fi&nd what:";
			// 
			// SearchTerms
			// 
			this.SearchTerms.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.SearchTerms.Location = new System.Drawing.Point(82, 14);
			this.SearchTerms.Name = "SearchTerms";
			this.SearchTerms.Size = new System.Drawing.Size(260, 21);
			this.SearchTerms.TabIndex = 1;
			// 
			// chkCaseSensitive
			// 
			this.chkCaseSensitive.Location = new System.Drawing.Point(12, 40);
			this.chkCaseSensitive.Name = "chkCaseSensitive";
			this.chkCaseSensitive.Size = new System.Drawing.Size(168, 20);
			this.chkCaseSensitive.TabIndex = 2;
			this.chkCaseSensitive.Text = "Match &case";
			// 
			// cmdFind
			// 
			this.cmdFind.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.cmdFind.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdFind.Location = new System.Drawing.Point(352, 14);
			this.cmdFind.Name = "cmdFind";
			this.cmdFind.TabIndex = 4;
			this.cmdFind.Text = "&Find";
			// 
			// cmdCancel
			// 
			this.cmdCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(352, 44);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.TabIndex = 5;
			this.cmdCancel.Text = "&Cancel";
			// 
			// chkWholeWord
			// 
			this.chkWholeWord.Location = new System.Drawing.Point(12, 62);
			this.chkWholeWord.Name = "chkWholeWord";
			this.chkWholeWord.Size = new System.Drawing.Size(168, 20);
			this.chkWholeWord.TabIndex = 3;
			this.chkWholeWord.Text = "Match &whole word";
			// 
			// SearchLocalFeeds
			// 
			this.AcceptButton = this.cmdFind;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(434, 96);
			this.Controls.Add(this.chkWholeWord);
			this.Controls.Add(this.cmdCancel);
			this.Controls.Add(this.cmdFind);
			this.Controls.Add(this.chkCaseSensitive);
			this.Controls.Add(this.SearchTerms);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "SearchLocalFeeds";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Search subscribed feeds";
			this.Load += new System.EventHandler(this.SearchLocalFeeds_Load);
			this.ResumeLayout(false);

		}
		#endregion

		#endregion 

		private static ArrayList	searchHistory = new ArrayList();
		private static bool			lastCaseSensitive = false;
		private static bool			lastMatchWholeWord = false;

		public static SearchTerms GetSearchTerms()
		{

			SearchLocalFeeds dlg = new SearchLocalFeeds();
			if( dlg.ShowDialog() != DialogResult.OK )
				return null;

			if( dlg.SearchTerms.Text.Trim() == "" )
				return null;

			SearchTerms search = new SearchTerms( 
				dlg.SearchTerms.Text.Trim(), 
				dlg.chkCaseSensitive.Checked, 
				dlg.chkWholeWord.Checked
				);

			return search;

		}

		private void SearchLocalFeeds_Load(object sender, System.EventArgs e)
		{

			foreach( string term in searchHistory )
				this.SearchTerms.Items.Insert( 0, term );

			this.chkCaseSensitive.Checked = lastCaseSensitive;
			this.chkWholeWord.Checked = lastMatchWholeWord;

			this.Closing += new CancelEventHandler(SearchLocalFeeds_Closing);

		}

		private void SearchLocalFeeds_Closing(object sender, CancelEventArgs e)
		{

			if( SearchTerms.Text == "" || this.DialogResult != DialogResult.OK )
				return;

			lastCaseSensitive = this.chkCaseSensitive.Checked;
			lastMatchWholeWord = this.chkWholeWord.Checked;
			searchHistory.Add( this.SearchTerms.Text );

		}

	}

}
