using System;
using System.Collections;

namespace RSSReader
{

	#region DateColumnComparer class 

	public class DateColumnComparer : IComparer
	{

		#region IComparer Members

		public int Compare(object x, object y)
		{

			DateTime dateLeft;
			DateTime dateRight;

			if( x is DateTime )
				dateLeft = (DateTime) x;
			else if( x is string )
				dateLeft = DateTime.Parse( (string) x );
			else
				return 0;

			if( y is DateTime )
				dateRight = (DateTime) y;
			else if( y is string )
				dateRight = DateTime.Parse( (string) y );
			else
				return 0;

			return dateLeft.CompareTo( dateRight );

		}

		#endregion

	}

	#endregion 

	#region IntColumnComparer class 

	public class IntColumnComparer : IComparer
	{

		#region IComparer Members

		public int Compare(object x, object y)
		{

			int intLeft;
			int intRight;

			if( x is int )
				intLeft = (int) x;
			else if( x is string )
				intLeft = int.Parse( (string) x );
			else
				return 0;

			if( y is int )
				intRight = (int) y;
			else if( y is string )
				intRight = int.Parse( (string) y );
			else
				return 0;

			return intLeft.CompareTo( intRight );

		}

		#endregion

	}

	#endregion 

}
